<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta http-equiv="X-UA-Compatible" content="ie=edge">
        <title>Document</title>                    

        <script type="module">
            import { LitElement, css, html } from 'https://unpkg.com/lit-element/lit-element.js?module';
            
            class Navigator extends LitElement
            {
                static get properties()
                {
                    return {
                        url: { type: String },
                    };
                }
                constructor()
                {
                    super();
                    this.url = "";
                }

                firstUpdated()
                {
                    super.firstUpdated();                    

                    const headerlist = this.shadowRoot.querySelector('div.header ul');
                    const menulist = this.shadowRoot.querySelector('div.menu ul');
                    const textField = this.shadowRoot.querySelector('div.main');
                    const aside = this.shadowRoot.querySelector('div.aside');

                    
                    const fetchData = async () => 
                    {
                        const response = await Promise.all([fetch(this.url)]);                
                        const content = JSON.parse(await Promise.all([response[0].text()]));            
                        createMenuButtons(content);
                    }

                    const createMenuButtons = (data) => {
                        data.forEach(element => {
                            createListItem(headerlist, element.toptheme, () => 
                            {
                                textField.innerHTML = element.description;
                                aside.innerHTML = `<a href="${element.url}" target="_blank">Weiter führende Links</a>`;
                                
                                createNavButtons(element.subthemes);
                            });
                        });
                    }

                    const removeNavButtons = () => {
                        var child = menulist.firstElementChild;
                        while (child)
                        {
                            menulist.removeChild(child);
                            child = menulist.firstElementChild;
                        }
                    }

                    const createNavButtons = (data) => {
                        removeNavButtons();
                        data.forEach(element => {
                            createListItem(menulist, element.subtheme, () =>
                            {
                                textField.innerHTML = element.description;
                                aside.innerHTML = `<a href="${element.url}" target="_blank">Weiter führende Links</a>`;
                            });
                        });
                    }

                    const createListItem = (list, theme, func) => 
                    {
                        const listItem = document.createElement('li');
                        list.appendChild(listItem);
                        listItem.innerHTML = `<div class="button">${theme}</div>`;
                        const deleteButton = listItem.querySelector('div');
                        deleteButton.onclick = () => func();
                    }

                    console.log("fetchdata: " + this.url);
                    fetchData();
                }

                static get styles()
                {
                    return css`
                        * { box-sizing: border-box; }
                        :root{
                            --header-height:20vh;
                            --footer-height:15vh;
                            --content-height: 75vh;
                            --main-height: var(--content-height);
                            --aside-height: var(--content-height);

                            font-family: sans-serif;
                        }
                        
                        ul {
                            list-style-type: none;
                            margin: 0;
                            padding: 0;
                            overflow: hidden;
                            background-color: #333333;
                        }

                        div.header ul li div.button 
                        {
                            float: left;
                        }

                        div.button {
                            display: block;
                            color: white;
                            text-align: center;
                            padding: 16px;
                            text-decoration: none;
                        }

                        div.button:hover {
                            background-color: #111111;
                            cursor: pointer;
                        }

                        .container {
                            display: flex;
                            flex-wrap: wrap;
                        }

                        .column
                        {
                            border-style: solid;
                            border-color: white;
                            border-width: 4px;
                        }

                        h2 {
                            text-align: center;
                        }

                        .header {
                            width: 100%;
                        }

                        .menu {
                            width: 20%;            
                        }

                        .main {
                            border-left: solid gray 1px;
                            border-right: solid gray 1px;
                            padding: 1em;
                            width: 60%;         
                            text-align: justify;
                            min-height: var(--main-height);       
                        }

                        .aside {
                            width: 20%;   
                            padding: 1em;      
                        }

                        .footer {
                            width: 100%;
                            color: white;
                            background: #333333;
                            padding: 1em;
                            min-height: var(--footer-height);       
                        }


                        @media screen and (max-width: 900px) {
                            :root{
                                --content-height: 90vh;
                            }
                            .aside {
                                width: 100%;      
                                border-top: solid black 1px;
                            }
                            .menu {
                                width: 30%;         
                            }
                            .main {
                                width: 70%;         
                                border-right: solid white 4px;
                            }
                        }

                        @media screen and (max-width: 450px) {
                            .main, .menu {
                                width: 100%;         
                                border: solid white 4px;
                            }
                        }
                    `;
                }
                
                render()
                {
                    return html`
                        <div class="container">
                            <div class="header column">
                                <h2>WWW-Navigator</h2>    
                                <ul></ul>
                            </div>
                            <div class="menu column"><ul></ul></div>
                            <div class="main column"></div>
                            <div class="aside column"></div>
                            <div class="footer column">Dieses Programm dient dazu verschiedene Funktionalitäten von HTML, CSS und JavaScript für den Anwender leicht zugänglich zu machen.</div>
                        </div>
                        `;
                }
            }

            customElements.define('general-navigator', Navigator)
        </script>
    </head>
    <body>        
        <general-navigator url="../06-ASYNC/Navigator.json"></general-navigator>
    </body>
</html>